// SPDX-License-Identifier: Apache-2.0
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
import { CommandHandler } from "../../../../../../core/decorator/CommandHandlerDecorator";
import AccountService from "../../../../../service/account/AccountService";
import SecurityService from "../../../../../service/security/SecurityService";
import { LockCommand, LockCommandResponse } from "./LockCommand";
import TransactionService from "../../../../../service/transaction/TransactionService";
import { lazyInject } from "../../../../../../core/decorator/LazyInjectDecorator";
import BigDecimal from "../../../../../../domain/context/shared/BigDecimal";
import { SecurityRole } from "../../../../../../domain/context/security/SecurityRole";
import ValidationService from "../../../../../service/validation/ValidationService";
import ContractService from "../../../../../service/contract/ContractService";
import { LockCommandError } from "./error/LockCommandError";
let LockCommandHandler = class LockCommandHandler {
    securityService;
    accountService;
    transactionService;
    validationService;
    contractService;
    constructor(securityService, accountService, transactionService, validationService, contractService) {
        this.securityService = securityService;
        this.accountService = accountService;
        this.transactionService = transactionService;
        this.validationService = validationService;
        this.contractService = contractService;
    }
    async execute(command) {
        try {
            const { securityId, amount, sourceId, expirationDate } = command;
            const handler = this.transactionService.getHandler();
            const account = this.accountService.getCurrentAccount();
            const security = await this.securityService.get(securityId);
            const securityEvmAddress = await this.contractService.getContractEvmAddress(securityId);
            const sourceEvmAddress = await this.accountService.getAccountEvmAddress(sourceId);
            await this.validationService.checkPause(securityId);
            await this.validationService.checkRole(SecurityRole._LOCKER_ROLE, account.id.toString(), securityId);
            await this.validationService.checkDecimals(security, amount);
            const amountBd = BigDecimal.fromString(amount, security.decimals);
            const res = await handler.lock(securityEvmAddress, sourceEvmAddress, amountBd, BigDecimal.fromString(expirationDate.substring(0, 10)), command.securityId);
            return Promise.resolve(new LockCommandResponse(res.error === undefined, res.id));
        }
        catch (error) {
            throw new LockCommandError(error);
        }
    }
};
LockCommandHandler = __decorate([
    CommandHandler(LockCommand),
    __param(0, lazyInject(SecurityService)),
    __param(1, lazyInject(AccountService)),
    __param(2, lazyInject(TransactionService)),
    __param(3, lazyInject(ValidationService)),
    __param(4, lazyInject(ContractService)),
    __metadata("design:paramtypes", [SecurityService,
        AccountService,
        TransactionService,
        ValidationService,
        ContractService])
], LockCommandHandler);
export { LockCommandHandler };
